package com.jz.sms.api;


import com.alibaba.fastjson.JSONObject;
import com.jz.sms.chuanglan.dto.CLBizResponse;
import com.jz.sms.chuanglan.dto.CLNotifyRequest;
import com.jz.sms.chuanglan.dto.ReportDto;
import com.jz.sms.chuanglan.service.ChuangLanSmsService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

@RequestMapping("/test/chuanglan")
@RestController
public class ChuangLanApi {

    private static final Logger log = LoggerFactory.getLogger(ChuangLanApi.class);

    @Autowired
    private ChuangLanSmsService chuangLanSmsService;

    @PostMapping("/notify")
    public String notify(@RequestParam CLNotifyRequest notifyInfo) {
        log.info("创蓝异步通知接口入参：{}", JSONObject.toJSONString(notifyInfo));

        chuangLanSmsService.asyncNotify(notifyInfo);


        String response = "success";
        log.info("创蓝异步通知接口出参：{}", response);
        return response;
    }

    @GetMapping("/report")
    public String report(ReportDto report) {
        log.info("回送报告接口入参：{}", JSONObject.toJSONString(report));
        CLBizResponse responses = chuangLanSmsService.report(report);
        String response = "success";
        log.info("创蓝异步通知接口出参：{}", response);
        return response;
    }


}
